<?php
/** 
 * @author 42functions | Ferdy Perdaan
 * @version 1.0
 */

add_action('wp_print_styles', 'xlii_smt_load');

function xlii_smt_load()
{
    if(xlii_smt_is_enabled() && count($buttons = xlii_smt_get_buttons('default')))
    {
        $settings = get_option('xlii_smt_ga', array('enabled' => false, 'tracking' => true));
        if($settings['enabled']) 
            echo '<script type="text/javascript">'.stripslashes($settings['code']).'</script>';
    
        // Enqueue button dependencies
        $types = array();
        foreach($buttons as &$primairy)
        {
            foreach($primairy as &$sub)
            {
                foreach($sub as &$button)
                {
                    if(!in_array($button['type'], $types))
                    {
                        $types[] = $button['type'];
                        wp_enqueue_script('xlii_smt_'.$button['type']);
                    }
                }
            }
        }
        
        do_action('xlii_smt_load', $types);
    
        // Enqueue styling and smt
        wp_enqueue_style('xlii_smt_front');
        wp_enqueue_script('xlii_smt_front');
        
        // Append tracking script
        if($settings['tracking'])
            wp_enqueue_script('xlii_smt_tracking');
        
        add_filter('the_content', 'xlii_smt_display');
        add_filter('the_excerpt', 'xlii_smt_display');  
    }
}

function xlii_smt_getsection($primairy, $sub, array &$buttons)
{
    if(isset($buttons[$primairy]) && isset($buttons[$primairy][$sub]))
    {
        $content = '<ul class = "xlii-smt-'.$sub.'">';
        foreach($buttons[$primairy][$sub] as &$button)
            $content .= '<li>'.xlii_smt_to_button($button).'</li>';
        return $content.'</ul>';
    }
    return '';
}

function xlii_smt_display($content)
{
    // Render top
    $buttons = xlii_smt_get_buttons('default');
    $append  = array('top' => '', 'bottom' => '');
    foreach($append as $section => &$html)
    {
        $html = xlii_smt_getsection($section, 'left', $buttons).
                xlii_smt_getsection($section, 'right', $buttons);
                
        if($html)
            $html = '<div class = "xlii-smt-location">'.$html.' <br class = "_clear"/></div>';
    }
    
    return $append['top'].$content.$append['bottom'];
}